package com.company;

import com.example.chatclient.Transport;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Server extends Thread {
    private int port;
    private boolean interrupt = false;
    private List<Client> clients = new ArrayList<>();
    private ServerSocket serverSocket;

    public Server(int port) {
        this.port = port;

        AdminWrite adminWrite = new AdminWrite();
        adminWrite.start();
    }

    @Override
    public void run() {
        System.out.println("\033[32mSERVER STARTUP\u001B[0m");

        try {

            serverSocket.bind(new InetSocketAddress("192.168.0.2", 9125));

            while (!isInterrupted() || !interrupt) {
                Socket clientSocket = serverSocket.accept();

                System.out.println("Connected new user from " + clientSocket.getRemoteSocketAddress().toString());

                try {
                    Client client = new Client(clientSocket, clients);
                    clients.add(client);
                    client.start();
                } catch (IOException e) {
                    System.out.println(e.getMessage());
                }
            }

        } catch (IOException e) {
            System.out.println(e.getMessage());
        }

        System.out.println("\033[31mSERVER SHUTDOWN\u001B[0m");
    }

    private class AdminWrite extends Thread {
        @Override
        public void run() {
            Scanner scanner = new Scanner(System.in);
            while (!isInterrupted()) {
                String message = scanner.nextLine();

                if (message.contains("exit")) {
                    try {
                        serverSocket.close();
                    } catch (IOException exception) {
                        exception.printStackTrace();
                    }
                    interrupt = true;
                }

                Transport t = new Transport();
                t.Name = "\033[1;36m\033[44m SERVER\u001B[0m";
                t.Message = message;
                for (Client client : clients) {
                    try {
                        ObjectOutputStream coos = new ObjectOutputStream(client.getSocket().getOutputStream());
                        coos.writeObject(t);
                        coos.flush();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }
}
